'
' NOTICE: Change the value for SetMAC, SetGetway, SetSubnet, and SetIP to match your network!!!
'
' Show how to get data from a form using the "GET" method
' Your inputs must be named "0" thru "9" for example
'   Name: <INPUT NAME="0"><BR>
'   City: <INPUT NAME="1"><BR>
'
'  VarExists[0] will be 1 if input "0" was sent otherwise it will be zero (same for "1" thru "9")
'  VarStr[0] will be a pointer to the string entered for the input (same for "1" thru "9")
'  Unchecked checkboxes do NOT return the input, checked checkboxes return the string "on"
'
' The variable VarFilename is a pointer to the filename specified in the URL (without the "/" prefix)
'
' If you have more than 10 inputs, you should probably be using the POST method
'
CON
  _clkmode = xtal1 + pll16x     'Use the PLL to multiple the external clock by 16
  _xinfreq = 5_000_000          'An external clock of 5MHz. is used (80MHz. operation)


CON
  CR            = 13
  LF            = 10
  QUOTE         = 34
  _bytebuffersize = 2048
  OPEN          =60
  CLOSE         =62
VAR

  'Configuration variables for the W5100
  byte  MAC[6]                  '6 element array contianing MAC or source hardware address ex. "02:00:00:01:23:45"
  byte  Gateway[4]              '4 element array containing gateway address ex. "192.168.0.1"
  byte  Subnet[4]               '4 element array contianing subnet mask ex. "255.255.255.0"
  byte  IP[4]                   '4 element array containing IP address ex. "192.168.0.13"
  long  localSocket             '1 element for the socket number

  'Variables to info for where to return the data to
  byte  destIP[4]               '4 element array containing IP address ex. "192.168.0.16"
  long  destSocket              '1 element for the socket number

  'Misc variables
  byte  data[_bytebuffersize]


  ' Get variables 0 thru 9
  long VarFilename ' pointer to string
  byte VarExists[10]
  long VarStr[10]   ' pointer to string
  Long DayTime
  byte Z1ST           'Zone 1 Start time
  byte Z1ET           'Zone 1 End time
             
   

OBJ
  ETHERNET      : "Brilldea_W5100_Indirect_Driver_Ver006.spin"
  rtc           : "S35390A_RTCEngine.spin"  
  pst           : "Parallax Serial Terminal.spin"
  
PUB main 

  pst.Start(115_200)
  pause(200)

  pst.str(string("Start RTC: "))
  rtc.RTCEngineStart(29, 28, -1)
  
  pause(200)
  
  'Start the W5100 driver on Parallax Web Server module
  ETHERNET.StartINDIRECT(0, 8, 9, 12, 11, 10, 14, 15)

  SetMAC($00, $08, $DC, $16, $EF, $5E) ' !!! CHANGE TO MATCH YOUR NETWORK !!!
  SetGateway(192, 168, 0, 1)           ' !!! CHANGE TO MATCH YOUR NETWORK !!!
  SetSubnet(255, 255, 255, 0)          ' !!! CHANGE TO MATCH YOUR NETWORK !!!
  SetIP(192, 168, 0, 252)              ' !!! CHANGE TO MATCH YOUR NETWORK !!!

  localSocket := 80 
  destSocket := 80  

  'Infinite loop of the server
  repeat
    pst.str(string("loop "))
    pst.bin(VarExists[0],1)
    pst.bin(VarExists[1],1)
    pst.bin(VarExists[2],1)
    pst.bin(VarExists[3],1)
    pst.bin(VarExists[4],1)
    pst.bin(VarExists[5],1)
    pst.str (VarStr[1]) 
    ETHERNET.SocketOpen(0, ETHERNET#_TCPPROTO, localSocket, destSocket, @destIP[0])
    ETHERNET.SocketTCPlisten(0)
    repeat while !ETHERNET.SocketTCPestablished(0)
    bytefill(@data, 0, _bytebuffersize)
    WaitCnt(clkfreq / 100 + cnt) ' 10mSec    
    ETHERNET.rxTCP(0, @data)
    DayTime := 0530
    
    if data[0] == "G" ' Assume a GET request
      ParseURL

       'Send the web page - hardcoded here
      'status line
      StringSend(0, string("HTTP/1.1 200 OK", CR, LF))
       
      'optional header
      StringSend(0, string("Server: Altitude AP LLC Lighting Control Modules/demo 1", CR))
      StringSend(0, string("Connection: close", CR))
      StringSend(0, string("Content-Type: text/html", CR, LF))
       
      'blank line
      StringSend(0, string(CR, LF))
       
      'File
      StringSend(0, string("<HTML>", CR))
      StringSend(0, string("<HEAD>", CR))
      StringSend(0, string("<TITLE>"))
      StringSend(0, string("Altitude AP LLC Lighting Control Modules"))
      StringSend(0, string("</TITLE>", CR))
      StringSend(0, string("</HEAD>", CR))

      StringSend(0, string("<BODY>", CR))
      StringSend(0, string("<H1>"))
      StringSend(0, string("American Traffic Solutions Tempe Facility Energy Management Controller"))
      StringSend(0, string("</H1>", CR))

      StringSend(0, string("<HR>", CR))

      StringSend(0, string("<P>This screen will display the current time as well as the loaded schedule.</P>", CR))

      'Zone 1 checkbox
      if VarExists[0] == 1
        DIRA[23] := 1
        OUTA[23] := 1
        StringSend(0, string("Zone 1 ON<BR>"))
      else
        DIRA[23] := 0
        StringSend(0, string("Zone 1 OFF<BR>"))
      'Zone 2 checkbox  
      if VarExists[1] == 1
       ' DIRA[23] := 1
        'OUTA[23] := 1
        StringSend(0, string("Zone 2 ON<BR>"))
      else
       ' DIRA[23] := 0
        StringSend(0, string("Zone 2 OFF<BR>"))
      'Zone 3 Checkbox
      if VarExists[2] == 1
       ' DIRA[23] := 1
       ' OUTA[23] := 1
        StringSend(0, string("Zone 3 ON<BR>"))
      else
        'DIRA[23] := 0
        StringSend(0, string("Zone 3 OFF<BR>"))   

          
      if byte[VarStr[1]] <> 0
        StringSend(0, string("Hello "))
        StringSend(0, VarStr[1])
        if byte[VarStr[2]] <> 0
          StringSend(0, string(" from "))
          StringSend(0, VarStr[2])
        StringSend(0, string("<BR>"))  

      StringSend(0, string("Filename is "))
      StringSend(0, VarFileName)
      StringSend(0, string("<BR>"))
      StringSend(0,string("<B> TESTING </B>"))
      
      StringSend(0, string("<FORM METHOD=", QUOTE, "GET", QUOTE, ">"))
         
      StringSend(0, string("<table border= 2 cellpadding=10>"))
      StringSend(0, string("<tr>"))
      StringSend(0, string("<th>Zone Number</th>"))
      StringSend(0, string("</tr>"))
      'First Row Header
      StringSend(0, string("<tr>"))
      StringSend(0, string("<th>Zone Number</th>"))
      StringSend(0, string("<th>Zone Discription</th>"))
      StringSend(0, string("<th>Start Time</th>"))
      StringSend(0, string("<th>End Time</th>"))
      StringSend(0, string("<th>On if CHECKED</th>"))
      StringSend(0, string("</tr>"))
      StringSend(0, string("<tr>"))
      'Second Row
      StringSend(0, string("<td>"))
      StringSend(0, string("1"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("2nd Floor East Side- South"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("05:00"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>")) 
      StringSend(0, string("LED: <INPUT TYPE=CHECKBOX"))
      if VarExists[0] == 1
        StringSend(0, string(" Checked=YES "))
      else
        StringSend(0, string(" "))
      StringSend(0, string("NAME= 0 >","<BR>"))
      StringSend(0, string("</td>"))       
      StringSend(0, string("</tr>"))
      'Third Row
      StringSend(0, string("<tr>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("2nd Floor East Side- Center"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>")) 
      StringSend(0, string("LED: <INPUT TYPE=CHECKBOX"))
      if VarExists[1] == 1
        StringSend(0, string(" Checked=YES "))
      else
        StringSend(0, string(" "))
      StringSend(0, string("NAME= 1 >","<BR>"))
      StringSend(0, string("</td>"))
      StringSend(0, string("</tr>"))
      'Forth Row
      StringSend(0, string("<tr>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("3"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("2nd Floor East Side- North"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>")) 
      StringSend(0, string("LED: <INPUT TYPE=CHECKBOX"))
      if VarExists[2] == 1
        StringSend(0, string(" Checked=YES "))
      else
        StringSend(0, string(" "))
      StringSend(0, string("NAME= 2 >","<BR>"))
      StringSend(0, string("</td>"))
      StringSend(0, string("</tr>"))
      'Fifth Row
      StringSend(0, string("<tr>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("4"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("2nd Floor West Side- South"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>")) 
      StringSend(0, string("LED: <INPUT TYPE=CHECKBOX"))
      if VarExists[3] == 1
        StringSend(0, string(" Checked=YES "))
      else
        StringSend(0, string(" "))
      StringSend(0, string("NAME= 3 >","<BR>"))
      StringSend(0, string("</td>"))
      StringSend(0, string("</tr>"))
     'Sixth Row
     StringSend(0, string("<tr>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("5"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("2nd Floor West Side- Center"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>")) 
      StringSend(0, string("LED: <INPUT TYPE=CHECKBOX"))
      if VarExists[4] == 1
        StringSend(0, string(" Checked=YES "))
      else
        StringSend(0, string(" "))
      StringSend(0, string("NAME= 4 >","<BR>"))
      StringSend(0, string("</td>"))
      StringSend(0, string("</tr>"))
      'Seventh Row
      StringSend(0, string("<tr>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("6"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("2nd Floor West Side- North"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>"))
      StringSend(0, string("row 1, cell 2"))
      StringSend(0, string("</td>"))
      StringSend(0, string("<td>")) 
      StringSend(0, string("LED: <INPUT TYPE=CHECKBOX"))
      if VarExists[5] == 1
        StringSend(0, string(" Checked=YES "))
      else
        StringSend(0, string(" "))
      StringSend(0, string("NAME= 5 >","<BR>"))
      StringSend(0, string("</td>"))
      StringSend(0, string("</tr>"))


      
 
      
  
      StringSend(0, string("</table>"))
      StringSend(0, string("<INPUT TYPE=SUBMIT><BR>")) 
      StringSend(0, string("</BODY>", CR))
      StringSend(0, string("</HTML>", CR))
      StringSend(0, string(CR, LF))
       
    ETHERNET.SocketTCPdisconnect(0)
    ETHERNET.SocketClose(0)

  return 'end of main
  

PRI Pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return
PRI SetMAC(p0, p1, p2, p3, p4, p5)
  MAC[0] := p0
  MAC[1] := p1
  MAC[2] := p2
  MAC[3] := p3
  MAC[4] := p4
  MAC[5] := p5
  ETHERNET.WriteMACaddress(true, @MAC[0])
   return 'end of SetMAC


PRI SetGateway(p0, p1, p2, p3)
  Gateway[0] := p0
  Gateway[1] := p1
  Gateway[2] := p2
  Gateway[3] := p3
  ETHERNET.WriteGatewayAddress(true, @Gateway[0])
  return 'end of SetGateway


PRI SetSubnet(p0, p1, p2, p3)
  Subnet[0] := p0
  Subnet[1] := p1
  Subnet[2] := p2
  Subnet[3] := p3
  ETHERNET.WriteSubnetMask(true, @SubNet[0])
  return 'end of SetSubnet


PRI SetIP(p0, p1, p2, p3)
  IP[0] := p0
  IP[1] := p1
  IP[2] := p2
  IP[3] := p3
  ETHERNET.WriteIPAddress(true, @IP[0])
  return 'end of SetIP


PRI StringSend(_socket, _dataPtr)
  if byte[_dataPtr] <> 0
    ETHERNET.txTCP(_socket, _dataPtr, strsize(_dataPtr))
  return 'end of StringSend


PRI ParseURL | char, inPlace, outPlace  ' !!! NOTICE - THIS MODIFIES data[] !!! 
  inPlace := 4 ' skip "GET "
  VarFileName := @data[5] ' Skip "GET /"
  
  repeat char from 0 to 9
    VarExists[char] := 0
    VarStr[char] := @EmptyStr

  repeat until (char == "?") or (char == " ")
    char := data[inPlace++]

  data[inPlace-1] := 0 ' String terminator for filename string
  outPlace := inPlace

  if char == "?"
    repeat until char == " "
      char := data[inPlace]
      if (char =< "9") and (char => "0")
        char := char - 48
        VarExists[char] := 1
        inPlace+=2 ' skip "x="
        VarStr[char] := @data[outPlace]   
        char := data[inPlace]
        if (char <> "&") and (char <> " ")
          data[outPlace++] := char
      repeat until (char == "&") or (char == " ")
        inPlace++
        char := data[inPlace]
        if (char <> "&") and (char <> " ")
          if char == "%"
            inPlace++
            char := data[inPlace++] - 48
            if char > 9
              char-=7
            char := char << 4
            data[outPlace]:=char
            char := data[inPlace] - 48
            if char > 9
              char-=7
            data[outPlace++]+=char
            char := "x" 
          else
            if char == "+"
              data[outPlace++] := " "
            else
              data[outPlace++] := char  
      data[outPlace++] := 0 ' String terminator
      inPlace++  
  return
  
DAT
  EmptyStr BYTE 0
    